divert(-1)
dnl Copyright (c) 2004 Mike Markley <mike@markley.org>
dnl
dnl By using this file, you agree to the terms and conditions set
dnl forth in the LICENSE file which can be found at the top level of
dnl the sendmail distribution.
dnl
dnl Usage:
dnl   place in the cf/hack directory and call as:
dnl     HACK(auth_from)
dnl Sites with simple configurations are done at this point, since by default
dnl  all usernames will be matched to username@domain & username@hostname.domain
dnl
dnl More advanced sites can use the Auth_From: tag in the access db like:
dnl Auth_From:user@example.com		fred
dnl Auth_From:@example.com		sue
dnl
dnl Other options include:
dnl define(confAUTHFROM_NO_LOCAL_DOMAINS) - disable the implicit matches for
dnl  your FQDN and domain name ($m and $j)
dnl define(confAUTHFROM_ALL_LOCAL_DOMAINS) - enable implicit matches for all
dnl  local domains ($=w)
dnl
dnl TODO:
dnl 	Make $j/$m exceptions optional
dnl 	Add optional exception for $=w
divert(0)
VERSIONID(`$Id: auth_from.m4,v 1.5 2005/06/16 03:33:40 madhack Exp $')
divert(-1)

ifdef(`_ACCESS_TABLE_',,`errprint(`*** ERROR: FEATURE(access_db) needed for auth_from
')')

define(`confAUTHFROM_PERM_ERROR',`"550 " $&{auth_authen} " not permitted to send as "')dnl

LOCAL_RULESETS
SLocal_check_mail
# Skip it if the user isn't authenticated -- let other checks handle that
R<$*>				$: < $1 > < $&{auth_authen} >
R<$*> <>			$@ <OK>
R<$*> <$*>			$: < $1 >
# Special-case for this machine's users
R<$*>				$: < $1 > < $1 >
ifdef(`confAUTHFROM_NO_LOCAL_DOMAINS',`',
`R<$&{auth_authen} @ $m> <$*>	$@ <OK>
R<$* @ $m> <$*>			$#error $@ 5.7.1 $: confAUTHFROM_PERM_ERROR $2
R<$&{auth_authen} @ $j> <$*>	$@ <OK>
R<$* @ $j> <$*>			$#error $@ 5.7.1 $: confAUTHFROM_PERM_ERROR $2
')dnl
ifdef(`confAUTHFROM_ALL_LOCAL_DOMAINS',
`R<$&{auth_authen} @ $=w> <$*>	$@ <OK>
R<$* @ $=w> <$*>		$#error $@ 5.7.1 $: confAUTHFROM_PERM_ERROR $2
')dnl
R<$*> $*			$: < $1 > $>SearchList <! Auth_From> $| <F:$1> <>
R<$* @ $*> <?>			$: < $1 @ $2 > $>SearchList <! Auth_From> $| <F:@$2> <>
R<$*> <<TMPF>>			$#error $@ 4.3.5 $: "451 Please try again later"
R<$*> <?>			$@ <OK>
R<$*> <$&{auth_authen}>		$@ <OK>
R<$*> $*			$#error $@ 5.7.1 $: confAUTHFROM_PERM_ERROR $1
